REM
REM  Adjust emulation timing
REM  Part of the zBoy project
REM  Copyright (C) Mateusz Viste 2010
REM

DIM SHARED AS ULONGINT TotalCycles ' ULONGINT is 64bit. Can go up to 18446744073709551615 (@4MHz = 139461 years)
DIM SHARED AS DOUBLE EmulationStartTimer
DIM SHARED AS UBYTE NoSpeedLimit = 0


#MACRO AdjustTiming()
  REM  Note: GameBoy speed is 4194304 CPU cycles/s
  IF (NoSpeedLimit = 0) THEN
    WHILE (TIMER - EmulationStartTimer) < (TotalCycles / 4194304) ' Loop until timing is right
      SLEEP 1,1
      IF (TIMER < EmulationStartTimer) THEN  ' Just in case the TIMER counter would wrap...
        EmulationStartTimer = TIMER
        TotalCycles = 0
      END IF
    WEND
  END IF
#ENDMACRO
