' netlin.bi by D.J.Peters (Joshy)
declare function htons cdecl alias "htons" (byval hvalue as ushort)   as short
declare function htonl cdecl alias "htonl" (byval hvalue as uinteger) as uinteger

declare function ntohs cdecl alias "ntohs" (byval hvalue as ushort)   as short
declare function ntohl cdecl alias "ntohl" (byval hvalue as uinteger) as uinteger

'0=error
declare function inet_aton cdecl alias "inet_aton" (byval Addrstr as string ,byval lpNetAddr as uinteger ptr) as integer
declare function inet_ntoa cdecl alias "inet_ntoa" (byval lpAddr  as uinteger ptr) as zstring ptr

#define build_addr(a,b,c,d) ((cuint(d) shl 24) or (cuint(c) shl 16) or (cuint(b) shl 8) or cuint(a))
#define build_port(p) cshort( (lobyte(p) shl 8) Or hibyte(p))

#ifndef NULL
#define NULL 0
#endif

type uint8_t     as ubyte
type sa_family_t as ushort 
type in_port_t   as ushort
type in_addr_t   as uinteger

' sockaddr_in: NetSendTo() NetRecvFrom() NetConnect() NetBind() NetAccept()
type SOCKADDR_IN field=1
  sin_family  as sa_family_t ' 16-Bit AF_xxxx
  sin_port    as in_port_t   ' 16-Bit TCP or UDP Port in net order
  sin_addr    as in_addr_t   ' 32-Bit addr in net order
  dummy1      as uinteger
  dummy2      as uinteger
end type

type SOCKADDR field=1
  sa_len      as uint8_t     ' 16=sizeof(SOCKADDR)
  sa_family   as sa_family_t ' AF_xxxx
  sa_data(14) as byte        ' diffrent usage based on sa_family
end type

enum SOCKET_TYPES
  SOCK_STREAM     = 1
  SOCK_DGRAM      = 2
  SOCK_RAW        = 3
  SOCK_RDM        = 4
  SOCK_SEQPACKET  = 5
  SOCK_PACKET     =10
end enum 

enum ADDR_FAMILIES
  AF_UNSPEC  = 0 ' Unspecified.
  AF_LOCAL       ' Local to host (pipes and file-domain).
  AF_INET        ' IP protocol family.
  AF_AX25        ' Amateur Radio AX.25.
  AF_IPX         ' Novell Internet Protocol.
  AF_APPLETALK   ' Appletalk DDP.
  AF_NETROM      ' Amateur radio NetROM.
  AF_BRIDGE      ' Multiprotocol bridge.
  AF_ATMPVC      ' ATM PVCs.
  AF_X25         ' Reserved for X.25 project.
  AF_INET6       ' IP version 6.
  AF_ROSE        ' Amateur Radio X.25 PLP.
  AF_DECnet      ' Reserved for DECnet project.
  AF_NETBEUI     ' Reserved for 802.2LLC project.
  AF_SECURITY    ' Security callback pseudo AF.
  AF_KEY         ' PF_KEY key management API.
  AF_NETLINK     ' PF_ROUTE=16 Alias to emulate 4.4BSD.
  AF_PACKET      ' Packet family.
  AF_ASH         ' Ash.
  AF_ECONET      ' Acorn Econet.
  AF_ATMSVC      ' ATM SVCs.
  AF_21
  AF_SNA         ' Linux SNA Project
  AF_IRDA        ' IRDA sockets.
  AF_PPPOX       ' PPPoX sockets.
  AF_WANPIPE     ' Wanpipe API sockets.
  AF_26
  AF_27
  AF_28
  AF_29
  AF_30
  AF_BLUETOOTH   ' Bluetooth sockets.
  AF_MAX         ' For now.
end enum



' gethostbyname() und gethostbyaddr()
type HOSTENT
  h_name       as zstring ptr     ' pointer to offical name of host
  h_aliases    as zstring ptr ptr ' pointer on array with pointers on aliases
  h_addrtype   as integer         ' host address type
  h_length     as integer         ' length of address
  union
    h_addr_list     as zstring  ptr ptr ' pointer on array eith pointers of addresses from nameserver
    h_addr_ip_list  as uinteger ptr ptr ' pointer on array eith pointers of addresses from nameserver
  end union
end type

declare function NetGetHostByName cdecl alias "gethostbyname" ( _
  byval as zstring ptr) as HOSTENT ptr
declare function NetGetHostByAddr cdecl alias "gethostbyaddr" ( _
  byval lpAddr   as uinteger ptr, _
  byval AddrSize as integer, _
  byval family   as ADDR_FAMILIES) as HOSTENT ptr

' Maximum queue length specifiable by listen.
const SOMAXCONN        = 128
' Address to accept any incoming messages.
const INADDR_ANY       as uinteger = &H00000000
' Address to send to all hosts.
const INADDR_BROADCAST as uinteger = &Hffffffff
' Address indicating an error return.
const INADDR_NONE      as uinteger = &Hffffffff

const SYS_SOCKET_CALL = 102

enum NET_CALLS
  SYS_SOCKET    = 1 ' ok sys_socket(2)
  SYS_BIND          ' ok sys_bind(2)
  SYS_CONNECT       ' ok sys_connect(2)
  SYS_LISTEN        ' ok sys_listen(2)
  SYS_ACCEPT        ' ok sys_accept(2)
  SYS_GETSOCKNAME   ' ok sys_getsockname(2)
  SYS_GETPEERNAME   ' ok sys_getpeername(2)
  SYS_SOCKETPAIR    ' sys_socketpair(2)
  SYS_SEND          ' NetWrite sys_send(2) same as write(fd)
  SYS_RECV          ' NetRead  sys_recv(2) same as read(fd)
  SYS_SENDTO        ' sys_sendto(2)
  SYS_RECVFROM      ' sys_recvfrom(2)
  SYS_SHUTDOWN      ' sys_shutdown(2)
  SYS_SETSOCKOPT    ' ok sys_setsockopt(2)
  SYS_GETSOCKOPT    ' ok sys_getsockopt(2)
  SYS_SENDMSG       ' sys_sendmsg(2)
  SYS_RECVMSG       ' sys_recvmsg(2)
end enum

' For setsockopt(2)
enum SOCK_LEVELS
  SOL_SOCKET   = 1
  SOL_RAW      =255
  SOL_DECNET   =261
  SOL_X25      =262
  SOL_PACKET   =263
  SOL_ATM      =264 ' ATM layer (cell level).  
  SOL_AAL      =265 ' ATM Adaption Layer (packet level).  
  SOL_IRDA     =266
end enum

enum SOCK_OPTIONS
  SO_DEBUG     = 1
  SO_REUSEADDR
  SO_TYPE
  SO_ERROR
  SO_DONTROUTE
  SO_BROADCAST
  SO_SNDBUF
  SO_RCVBUF
  SO_KEEPALIVE
  SO_OOBINLINE
  SO_NO_CHECK
  SO_PRIORITY
  SO_LINGER
  SO_BSDCOMPAT
  SO_REUSEPORT
  SO_PASSCRED
  SO_PEERCRED
  SO_RCVLOWAT
  SO_SNDLOWAT
  SO_RCVTIMEO
  SO_SNDTIMEO
  SO_SECURITY_AUTHENTICATION
  SO_SECURITY_ENCRYPTION_TRANSPORT
  SO_SECURITY_ENCRYPTION_NETWORK
  SO_BINDTODEVICE
  SO_ATTACH_FILTER
  SO_DETACH_FILTER
  SO_PEERNAME
  SO_TIMESTAMP
  SO_ACCEPTCONN
  SO_PEERSEC
end enum
#define SCM_TIMESTAMP   SO_TIMESTAMP


type FDSOCKET as integer

' NetSocket address_family,socket_type [,protocol]
function NetSocket(byval af as ADDR_FAMILIES, _
                   byval st as SOCKET_TYPES, _
                   byval protocol as integer=0) as FDSOCKET
  dim as integer ptr lpArgs
  lpArgs=allocate(sizeof(integer)*3)
  lpArgs[0]=af
  lpArgs[1]=st
  lpArgs[2]=protocol
  asm mov eax,sys_socket_call
  asm mov ebx,sys_socket
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

' NetBind hSocket,lpSOCKKADDR_IN [,Addrsize]
function NetBind(byval hSocket  as FDSOCKET, _
                 byval lpAddr   as SOCKADDR_in ptr, _
                 byval addrsize as integer=sizeof(SOCKADDR_in)) as integer
  dim as integer ptr lpArgs
  lpArgs=allocate(sizeof(integer)*3)
  lpArgs[0]=hSocket
  lpArgs[1]=cint(lpAddr)
  lpArgs[2]=addrsize
  asm mov eax,sys_socket_call
  asm mov ebx,sys_bind
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

' NetListen hSocket [,MaxWaitingConnections]
function NetListen(byval hSocket as FDSOCKET, _
                   byval nc      as integer=3) as integer
  dim as integer ptr lpArgs
  lpArgs=allocate(sizeof(integer)*2)
  lpArgs[0]=hSocket
  lpArgs[1]=nc
  asm mov eax,sys_socket_call
  asm mov ebx,sys_listen
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

' NetAccept hSocket,lpSOCKADDR_IN,lpAddrsize
function NetAccept(byval hSocket  as FDSOCKET, _
                   byval lpAddr   as SOCKADDR_in ptr, _
                   byval addrsize as integer ptr) as integer
  dim as integer ptr lpArgs
  lpArgs=allocate(sizeof(integer)*3)
  lpArgs[0]=hSocket
  lpArgs[1]=cint(lpAddr)
  lpArgs[2]=cint(addrsize)
  asm mov eax,sys_socket_call
  asm mov ebx,sys_accept
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

' NetConnect hSocket,lpSOCKADDR_IN [,Addrsize]
function NetConnect(byval hSocket  as FDSOCKET, _
                    byval lpAddr   as SOCKADDR_in ptr, _
                    byval addrsize as integer=sizeof(SOCKADDR_in)) as integer
  dim as integer ptr lpArgs
  lpArgs=allocate(sizeof(integer)*3)
  lpArgs[0]=hSocket
  lpArgs[1]=cint(lpAddr)
  lpArgs[2]=addrsize
  asm mov eax,sys_socket_call
  asm mov ebx,sys_connect
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

' NetGetSockName hSocket,lpSOCKADDR_IN
function NetGetSockName(byval hSocket    as FDSOCKET, _
                        byval lpAddr     as SOCKADDR_in ptr, _
                        byval lpAddrsize as integer ptr) as integer
  dim as integer ptr lpArgs
  dim as integer i,l
  lpArgs  =allocate(sizeof(integer)*3)
  lpArgs[0]=hSocket
  lpArgs[1]=cint(lpAddr)
  lpArgs[2]=cint(lpAddrsize)
  asm mov eax,sys_socket_call
  asm mov ebx,sys_getsockname
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

' NetGetPeerName hSocket,lpSOCKADDR_IN,lpAddrsize
function NetGetPeerName(byval hSocket    as FDSOCKET, _
                        byval lpAddr     as SOCKADDR_in ptr, _
                        byval lpAddrsize as integer ptr) as integer
  dim as integer ptr lpArgs
  dim as integer     i,l
  lpArgs   =allocate(sizeof(integer)*3)
  lpArgs[0]=hSocket
  lpArgs[1]=cint(lpAddr)
  lpArgs[2]=cint(lpAddrSize)
  asm mov eax,sys_socket_call
  asm mov ebx,sys_getpeername
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

'<0 error
function NetWrite(byval hSocket  as FDSOCKET, _
                  byval lpBuffer as any ptr, _
                  byval nBytes   as integer) as integer
  asm mov eax, 4
  asm mov ebx, [hSocket]
  asm mov ecx, [lpBuffer]
  asm mov edx, [nBytes]
  asm int &H80
  asm mov [function],eax
end function

'<0 error 0=connection lost
function NetRead(byval hSocket  as FDSOCKET, _
                 byval lpBuffer as any ptr, _
                 byval nBytes   as integer) as integer
  asm mov eax,3
  asm mov ebx, [hSocket]
  asm mov ecx, [lpBuffer]
  asm mov edx, [nBytes]
  asm int &H80
  asm mov [function],eax
end function

function NetClose(byval hSocket as FDSOCKET) as integer
  asm mov eax,6
  asm mov ebx,[hSocket]
  asm int &H80
  asm mov [function],eax
end function

'<0 error
function NetSendString(byval hSocket as FDSOCKET,byval message as string) as integer
  dim as byte ptr lpBuffer
  dim as integer l,i
  l=len(message)
  if l=0 then return 0
  lpBuffer=allocate(l)
  for i=0 to l-1
    lpBuffer[i]=message[i]
  next
  NetSendString=NetWrite(hSocket,lpBuffer,l)
  deallocate(lpBuffer)
end function

'<0 error 0=connection lost
function NetReceiveString(byval hSocket as FDSOCKET,byref message as string) as integer
  dim lpBuffer as ubyte ptr
  dim as integer l,i
  message=""
  lpBuffer=allocate(1024*64)
  l=NetRead(hSocket,lpBuffer,1024*64)
  if l>0 then
    for i=0 to l-1
      message=message & chr(lpBuffer[i])
    next
  end if
  deallocate(lpBuffer)
  return l
end function

function NetSetSockOpt( byval hSocket    as FDSOCKET, _
                        byval Level      as SOCK_LEVELS, _
                        byval OptionName as SOCK_OPTIONS, _
                        byval lpValue    as any ptr, _
                        byval Valuesize  as integer ) as integer
  dim as integer ptr lpArgs
  lpArgs   =allocate(sizeof(integer)*5)
  lpArgs[0]=hSocket
  lpArgs[1]=Level
  lpArgs[2]=OptionName
  lpArgs[3]=cint(lpValue)
  lpArgs[4]=Valuesize
  asm mov eax,sys_socket_call
  asm mov ebx,sys_setsockopt
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function

function NetGetSockOpt( byval hSocket      as FDSOCKET, _
                        byval Level        as SOCK_LEVELS, _
                        byval OptionName   as SOCK_OPTIONS, _
                        byval lpValue      as any ptr, _
                        byval lpValuesize  as integer ptr) as integer
  dim as integer ptr lpArgs
  lpArgs   =allocate(sizeof(integer)*5)
  lpArgs[0]=hSocket
  lpArgs[1]=Level
  lpArgs[2]=OptionName
  lpArgs[3]=cint(lpValue)
  lpArgs[4]=cint(lpValuesize)
  asm mov eax,sys_socket_call
  asm mov ebx,sys_setsockopt
  asm mov ecx,[lpArgs]
  asm int &H80
  asm mov [function],eax
  deallocate lpArgs
end function
