' netwin.bi by D.J.Peters (Joshy)
#inclib "ws2_32"
#define build_addr(a,b,c,d) cuint((cuint(d) Shl 24) Or (cuint(c) Shl 16) Or (cuint(b) Shl 8) Or cuint(a))
#define build_port(p) cshort( (lobyte(p) shl 8) Or hibyte(p))

Enum ADDR_FAMILY
  AF_UNSPEC    =  0 ' Unspecified.    
  AF_UNIX      =  1 ' Local to host (pipes and file-domain).
  AF_INET      =  2 ' IP protocol family.
  AF_IMPLINK   =  3
  AF_PUP       =  4
  AF_CHAOS     =  5
  AF_IPX       =  6 ' Novell Internet Protocol.
  AF_OSI_ISO   =  7
  AF_ECMA      =  8
  AF_DATAKIT   =  9
  AF_CCITT     = 10
  AF_SNA       = 11
  AF_DECnet    = 12 ' Reserved for DECnet project.
  AF_DLI       = 13
  AF_LAT       = 14
  AF_HYLINK    = 15
  AF_APPLETALK = 16 ' Appletalk DDP.
  AF_NETBIOS   = 17
  AF_VOICEVIEW = 18
  AF_FIREFOX   = 19
  AF_UNKNOWN1  = 20
  AF_BAN       = 21
  AF_ATM       = 22
  AF_INET6     = 23
  AF_CLUSTER   = 24
  AF_12844     = 25
  AF_MAX       = 26
End Enum

enum SOCKET_TYPES
  SOCK_STREAM     = 1
  SOCK_DGRAM      = 2
  SOCK_RAW        = 3
  SOCK_RDM        = 4
  SOCK_SEQPACKET  = 5
End enum 

Enum SOCKET_PROTOCOLS
  IPPROTO_IP   =   0
  IPPROTO_ICMP =   1
  IPPROTO_IGMP =   2
  IPPROTO_GGP  =   3
  IPPROTO_TCP  =   6
  IPPROTO_PUP  =  12
  IPPROTO_UDP  =  17
  IPPROTO_IDP  =  22
  IPPROTO_ND   =  77
  IPPROTO_RAW  = 255
  IPPROTO_MAX  = 256
End Enum


' Maximum queue length specifiable by listen.
Const SOMAXCONN        As Uinteger = &H7FFFFFFF
' Address to accept any incoming messages.
Const INADDR_ANY       As Uinteger = &H00000000
' Address to send to all hosts.
Const INADDR_BROADCAST As Uinteger = &Hffffffff
' Address indicating an error return.
Const INADDR_NONE      As Uinteger = &Hffffffff
Const SOCKET_ERROR   =  1
Const INVALID_SOCKET = -1


Enum WSAVERSIONS
  VERSION_11 = &H0101
  VERSION_22 = &H0202
End Enum
Type WSAData
  wVersion       As Short
  wHighVersion   As Short
  szDescription  As zString * 256
  szSystemStatus As zString * 256
  iMaxSockets    As Ushort
  iMaxUdpDg      As Ushort
  lpVendorInfo   As Any Ptr
End Type

Type HOSTENT Field=1
  h_name     As Zstring Ptr     ' lpString offical name of host
  h_aliases  As Zstring Ptr ptr ' lplpString alias list
  h_addrtype As Ushort          ' host address type
  h_length   As Ushort          ' length of address
  Union
  h_addr_list    As Zstring Ptr ptr ' lplpString list of addresses from nameserver
  h_addr_ip_list As Uinteger Ptr ptr
  End Union
End Type
#define h_addr h_addr_list[0]

Type servent
  s_name    As Integer
  s_aliases As Integer
  s_port    As Short
  s_proto   As Integer
End Type

Type protoent
  p_name    As String    'Official name of the protocol
  p_aliases As Integer   'Null-terminated array of alternate names
  p_proto   As Integer   'Protocol number, in host byte order
End Type

Type SOCKADDR Field = 1
  sin_family  As Short
  sin_port    As Short
  sin_addr    As Uinteger
  sin_dummy1  As Integer
  sin_dummy2  As Integer
End Type
type SOCKADDR_IN As SOCKADDR 

Type FDSOCKET As Integer

Type timeval
  tv_sec  As Integer   'seconds
  tv_usec As Integer   'and microseconds
End Type

Const FD_SETSIZE = 64
Type fd_set
  fd_count                  As Integer '// how many are SET?
  fd_array(1 To FD_SETSIZE) As Integer '// an array of SOCKETs
End Type
' Lib "ws2_32.dll"
Declare Function WSAGetLastError  Alias "WSAGetLastError" () As Integer

Declare Function WSAStartup  Alias "WSAStartup" ( _
  Byval Version  As WSAVERSIONS, _
  Byval lpData   As WSAData Ptr) As Integer

Declare Function WSACleanup  Alias "WSACleanup" () As Integer

Declare Function NetGetHostByAddr  Alias "gethostbyaddr" ( _
  Byval lpAddr    As Uinteger,  _
  Byval addr_len  As Integer, _
  Byval addr_type As Integer) As Integer

Declare Function NetGetHostByName  Alias "gethostbyname" ( _
  Byval host_name As String) As HOSTENT Ptr

Declare Function NetGetHostname  Alias "gethostname" ( _
  Byval host_name As String, _
  Byval namelen   As Integer) As Integer

Declare Function NetGetServerByName  Alias "getservbyname" ( _
  Byval serv_name As String, _
  Byval proto     As String) As Integer

Declare Function getprotobynumber  ( _
  Byval  proto As Integer) As Integer

Declare Function getprotobyname  ( _
  Byval  proto_name As String) As Integer

Declare Function getservbyport  ( _
  Byval port  As  Short, _
  Byval proto As Integer) As Integer

Declare Function NetInet_Addr  Alias "inet_addr" ( _
  Byref cp          As  Zstring Ptr) As Integer

Declare Function NetInet_ntoa  Alias "inet_ntoa" ( _
  Byval inn         As Uinteger) As Zstring Ptr

Declare Function htons  Alias "htons" ( _
  Byval HostValue  As Short) As Short
Declare Function htonl  Alias "htonl" ( _
  Byval HostValue  As Integer) As Integer
Declare Function ntohl  Alias "ntohl" ( _
  Byval NetValue As Integer) As Integer
Declare Function ntohs  Alias "ntohs" ( _
  Byval NetValue   As Short) As Short

Declare Function NetSocket  Alias "socket" ( _
  Byval AF         As ADDR_FAMILY, _
  Byval ST         As SOCKET_TYPES, _
  Byval Protocol   As SOCKET_PROTOCOLS=0) As Integer

Declare Function NetClose  Alias "closesocket" ( _
  Byval hSocket    As FDSOCKET) As Integer

Declare Function NetConnect  Alias "connect"( _
  Byval hSocket    As FDSOCKET, _
  Byval lpAddr     As sockaddr_in Ptr, _
  Byval AddrSize   As Integer=sizeof(sockaddr_in)) As Integer

Declare Function NetGetSockName  Alias "getsockname" ( _
  Byval hSocket    As FDSOCKET, _
  Byval lpAddr     As sockaddr_in Ptr , _
  Byval lpAddrSize As Integer Ptr) As Integer

Declare Function NetGetPeerName  Alias "getpeername"  ( _
  Byval hSocket    As FDSOCKET, _
  Byval lpAddr     As sockaddr_in Ptr, _
  Byval lpAddrSize As Integer Ptr) As Integer

Declare Function NetBind  Alias "bind" ( _
  Byval hSocket    As FDSOCKET, _
  Byval lpAddr     As sockaddr_in Ptr, _
  Byval addrsize   As integer=sizeof(SOCKADDR_in)) As Integer

Declare Function NetListen  Alias "listen" ( _
  Byval hSocket    As FDSOCKET,  _
  Byval nC         As Integer=3) As Integer

Declare Function NetAccept  Alias "accept"( _
  Byval hSocket    As FDSOCKET,  _
  Byval lpAddr     As sockaddr_in Ptr, _
  Byval lpAddrSize As Integer Ptr) As Integer


Declare Function NetSelect  Alias "select" ( _
  Byval nfds       As Integer, _
  Byref readfds    As Any,     _
  Byref writefds   As Any,     _
  Byref exceptfds  As Any,     _
  Byref timeout    As Integer) As Integer

Declare Function NetRead  Alias "recv" ( _
  Byval hSocket    As FDSOCKET, _
  Byval lpBuffer   As Any Ptr, _
  Byval BufferSize As Integer, _
  Byval Flags      As Integer) As Integer

Declare Function NetWrite  Alias "send" ( _
  Byval hSocket    As FDSOCKET, _
  Byval lpBuffer   As Any Ptr, _
  Byval BufferSize As Integer, _
  Byval Flags      As Integer) As Integer

Sub _init() Constructor
  Dim As WSADATA  wsData
  Dim As Integer  ret
  ret=WSAStartup(VERSION_11,@wsData)
  If ret<>0 Then
    ? "error: WSAStartup!"
    beep:Sleep:End -1
  End If
End Sub
Sub _exit() Destructor
  WSACleanup
End Sub

'helpers if you won't send buffers of bytes
Function NetSendString(Byval hSocket As FDSOCKET,Byval message As String) As Integer
  Dim lpBuffer As Ubyte Ptr
  Dim As Integer l,i
  l=Len(message)
  If l=0 Then Return 0
  lpBuffer=allocate(l)
  For i=0 To l-1
    lpBuffer[i]=message[i]
  Next
  Function=NetWrite(hSocket,lpBuffer,l,0)
  deallocate(lpBuffer)
End Function
'<0 error 0=connection lost
Function NetReceiveString(Byval hSocket As FDSOCKET,Byref message As String) As Integer
  Dim lpBuffer As Ubyte Ptr
  Dim As Integer l,i
  message=""
  lpBuffer=allocate(1024*64)
  l=NetRead(hSocket,lpBuffer,1024*64,0)
  if l>0 then
    For i=0 To l-1
      message=message & Chr(lpBuffer[i])
    Next
  end if
  deallocate(lpBuffer)
  return l
End Function

Declare Function getsockopt  ( _ 
Byval hSocket    As FDSOCKET, _
Byval Level      As Integer, _
Byval OptName    As Integer, _
Byval lpOptValue As Any Ptr, _
Byval lpOptSize  As Integer Ptr) As Integer

Const WSABASEERR             = 10000
Const WSADESCRIPTION_LEN     = 257
Const WSASYS_STATUS_LEN      = 129
Const WSAEINTR               = (WSABASEERR + 4)
Const WSAEBADF               = (WSABASEERR + 9)
Const WSAEACCES              = (WSABASEERR + 13)
Const WSAEFAULT              = (WSABASEERR + 14)
Const WSAEINVAL              = (WSABASEERR + 22)
Const WSAEMFILE              = (WSABASEERR + 24)
Const WSAEWOULDBLOCK         = (WSABASEERR + 35)
Const WSAEINPROGRESS         = (WSABASEERR + 36)
Const WSAEALREADY            = (WSABASEERR + 37)
Const WSAENOTSOCK            = (WSABASEERR + 38)
Const WSAEDESTADDRREQ        = (WSABASEERR + 39)
Const WSAEMSGSIZE            = (WSABASEERR + 40)
Const WSAEPROTOTYPE          = (WSABASEERR + 41)
Const WSAENOPROTOOPT         = (WSABASEERR + 42)
Const WSAEPROTONOSUPPORT     = (WSABASEERR + 43)
Const WSAESOCKTNOSUPPORT     = (WSABASEERR + 44)
Const WSAEOPNOTSUPP          = (WSABASEERR + 45)
Const WSAEPFNOSUPPORT        = (WSABASEERR + 46)
Const WSAEAFNOSUPPORT        = (WSABASEERR + 47)
Const WSAEADDRINUSE          = (WSABASEERR + 48)
Const WSAEADDRNOTAVAIL       = (WSABASEERR + 49)
Const WSAENETDOWN            = (WSABASEERR + 50)
Const WSAENETUNREACH         = (WSABASEERR + 51)
Const WSAENETRESET           = (WSABASEERR + 52)
Const WSAECONNABORTED        = (WSABASEERR + 53)
Const WSAECONNRESET          = (WSABASEERR + 54)
Const WSAENOBUFS             = (WSABASEERR + 55)
Const WSAEISCONN             = (WSABASEERR + 56)
Const WSAENOTCONN            = (WSABASEERR + 57)
Const WSAESHUTDOWN           = (WSABASEERR + 58)
Const WSAETOOMANYREFS        = (WSABASEERR + 59)
Const WSAETIMEDOUT           = (WSABASEERR + 60)
Const WSAECONNREFUSED        = (WSABASEERR + 61)
Const WSAELOOP               = (WSABASEERR + 62)
Const WSAENAMETOOinteger     = (WSABASEERR + 63)
Const WSAEHOSTDOWN           = (WSABASEERR + 64)
Const WSAEHOSTUNREACH        = (WSABASEERR + 65)
Const WSAENOTEMPTY           = (WSABASEERR + 66)
Const WSAEPROCLIM            = (WSABASEERR + 67)
Const WSAEUSERS              = (WSABASEERR + 68)
Const WSAEDQUOT              = (WSABASEERR + 69)
Const WSAESTALE              = (WSABASEERR + 70)
Const WSAERemOTE             = (WSABASEERR + 71)
Const WSASYSNOTREADY         = (WSABASEERR + 91)
Const WSAVERNOTSUPPORTED     = (WSABASEERR + 92)
Const WSANOTINITIALISED      = (WSABASEERR + 93)
Const WSAEDISCON             = (WSABASEERR + 101)
Const WSAENOMORE             = (WSABASEERR + 102)
Const WSAECANCELLED          = (WSABASEERR + 103)
Const WSAEINVALIDPROCTABLE   = (WSABASEERR + 104)
Const WSAEINVALIDPROVIDER    = (WSABASEERR + 105)
Const WSAEPROVIDERFAILEDINIT = (WSABASEERR + 106)
Const WSASYSCALLFAILURE      = (WSABASEERR + 107)
Const WSASERVICE_NOT_FOUND   = (WSABASEERR + 108)
Const WSATYPE_NOT_FOUND      = (WSABASEERR + 109)
Const WSA_E_NO_MORE          = (WSABASEERR + 110)
Const WSA_E_CANCELLED        = (WSABASEERR + 111)
Const WSAEREFUSED            = (WSABASEERR + 112)
Const WSAHOST_NOT_FOUND      = (WSABASEERR +1001)
Const WSATRY_AGAIN           = (WSABASEERR +1002)
Const WSANO_RECOVERY         = (WSABASEERR +1003)
Const WSANO_DATA             = (WSABASEERR +1004)

Function GetErrorString(Byval ErrCode As Integer) As String
  Dim ret As String
  Select Case ErrCode
    Case WSAEACCES         :ret = "Permission denied."
    Case WSAEADDRINUSE     :ret = "Address already in use."
    Case WSAEADDRNOTAVAIL  :ret = "Cannot assign requested address."
    Case WSAEAFNOSUPPORT   :ret = "Address family not supported by protocol family."
    Case WSAEALREADY       :ret = "Operation already in progress."
    Case WSAECONNABORTED   :ret = "Software caused connection abort."
    Case WSAECONNREFUSED   :ret = "Connection refused."
    Case WSAECONNRESET     :ret = "Connection reset by peer."
    Case WSAEDESTADDRREQ   :ret = "Destination address required."
    Case WSAEFAULT         :ret = "Bad address."
    Case WSAEHOSTDOWN      :ret = "Host is down."
    Case WSAEHOSTUNREACH   :ret = "No route to host."
    Case WSAEINPROGRESS    :ret = "Operation now in progress."
    Case WSAEINTR          :ret = "Interrupted function call."
    Case WSAEINVAL         :ret = "Invalid argument."
    Case WSAEISCONN        :ret = "Socket is already connected."
    Case WSAEMFILE         :ret = "Too many open files."
    Case WSAEMSGSIZE       :ret = "Message too integer."
    Case WSAENETDOWN       :ret = "Network is down."
    Case WSAENETRESET      :ret = "Network dropped connection on reset."
    Case WSAENETUNREACH    :ret = "Network is unreachable."
    Case WSAENOBUFS        :ret = "No buffer space available."
    Case WSAENOPROTOOPT    :ret = "Bad protocol option."
    Case WSAENOTCONN       :ret = "Socket is not connected."
    Case WSAENOTSOCK       :ret = "Socket operation on nonsocket."
    Case WSAEOPNOTSUPP     :ret = "Operation not supported."
    Case WSAEPFNOSUPPORT   :ret = "Protocol family not supported."
    Case WSAEPROCLIM       :ret = "Too many processes."
    Case WSAEPROTONOSUPPORT:ret = "Protocol not supported."
    Case WSAEPROTOTYPE     :ret = "Protocol wrong type for socket."
    Case WSAESHUTDOWN      :ret = "Cannot send after socket shutdown."
    Case WSAESOCKTNOSUPPORT:ret = "Socket type not supported."
    Case WSAETIMEDOUT      :ret = "Connection timed out."
    Case WSATYPE_NOT_FOUND :ret = "Class type not found."
    Case WSAEWOULDBLOCK    :ret = "Resource temporarily unavailable."
    Case WSAHOST_NOT_FOUND :ret = "Host not found."
    Case WSANOTINITIALISED :ret = "Successful WSAStartup not yet performed."
    Case WSANO_DATA        :ret = "Valid name, no data record of requested type."
    Case WSANO_RECOVERY    :ret = "This is a nonrecoverable error."
    Case WSASYSCALLFAILURE :ret = "System call failure."
    Case WSASYSNOTREADY    :ret = "Network subsystem is unavailable."
    Case WSATRY_AGAIN      :ret = "Nonauthoritative host not found."
    Case WSAVERNOTSUPPORTED:ret = "Winsock.dll version out of range."
    Case WSAEDISCON        :ret = "Graceful shutdown in progress."
    Case Else              :ret = "Unknown error."
  End Select
  Function = ret
End Function
