REM
REM This file is part of the zBoy project.
REM Copyright (C) Mateusz Viste 2010, 2011
REM

#DEFINE SaveScoresFile (SaveDir & HEX(RomInfos.CRCsum, 8) & ".hi")
DIM SHARED SaveScoresWriteProtection(1 TO 2048) AS UINTEGER


#MACRO WriteChecksumValue()
  HiScoreCheckSum = (HiScoreCheckSum XOR XorKey)
  PUT #FileHandler,, HiScoreCheckSum
#ENDMACRO


SUB SaveHiScoresMem()
  'DIM AS UBYTE UbyteBuff1, UbyteBuff2
  DIM AS UINTEGER FileHandler, UintVar
  DIM AS USHORT HiScoreCheckSum = 1985, XorKey = 1983
  FileHandler = FREEFILE
  GetSaveDir()  ' provides the SaveDir variable
  IF IsDirectory(SaveDir) = 0 THEN
    MKDIR SaveDir
  END IF
  SELECT CASE RomInfos.CrcSum
    CASE &h0509069C, &hB681E243  ' Pac-Man
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hFF8C TO &hFF8E
        PUT #FileHandler,, MemoryInternalHiRAM(UintVar)
        HiScoreCheckSum += MemoryInternalHiRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &h0E5BB1C4 ' Ms. Pac-Man
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hD8C7 TO &hD8C9
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &hF59CEDEA  ' Pipe Dream
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hC212 TO &hC22C
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &h2C27EC70, &h90776841  ' Super Marioland v1.1 and Super Marioland v1.0
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hC0C0 TO &hC0C3
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &h63F9407D, &h46DF91AD  ' Tetris v1.0 and v1.1
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hD000 TO &hD761
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &hC1F88833  ' Asteroids
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hDB00 TO &hDB53
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &hA37A814A  ' BattleCity
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hCA02 TO &hCA06
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &hB76C769B  ' Tetris Attack v1.0
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hCF00 TO &hCF2C
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &h6C742478  ' Dig Dug
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hDE08 TO &hDE17
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
    CASE &h6A6ECFEC  ' Galaga & Galaxian
      OPEN SaveScoresFile FOR OUTPUT AS FileHandler
      FOR UintVar = &hD70D TO &hD716
        PUT #FileHandler,, MemoryInternalRAM(UintVar)
        HiScoreCheckSum += MemoryInternalRAM(UintVar)
      NEXT UintVar
      WriteChecksumValue()
      CLOSE FileHandler
  END SELECT
END SUB


#MACRO CheckSumVerification()
  GET #FileHandler,, SavedCheckSum
  SavedCheckSum = (SavedCheckSum XOR XorKey)
  IF HiScoreCheckSum <> SavedChecksum THEN  ' Something fishy is going on here!
    FOR UintVar = 1 TO 2048                 ' Ignore what we've done a second ago.
      SaveScoresWriteProtection(UintVar) = 0
    NEXT UintVar
  END IF
#ENDMACRO


SUB LoadHiScoresMem()
  'DIM AS UBYTE UbyteBuff1, UbyteBuff2
  DIM AS UINTEGER FileHandler, UintVar
  DIM AS USHORT HiScoreCheckSum = 1985, SavedCheckSum, XorKey = 1983
  FileHandler = FREEFILE
  GetSaveDir()  ' provides the SaveDir variable
  SELECT CASE RomInfos.CrcSum
    CASE &h0509069C, &hB681E243  ' Pac-Man
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hFF8C TO &hFF8E
          GET #FileHandler,, MemoryInternalHiRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hFF8B) = UintVar
          HiScoreCheckSum += MemoryInternalHiRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &h0E5BB1C4 ' Ms. Pac-Man
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hD8C7 TO &hD8C9
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hD8C6) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &hF59CEDEA  ' Pipe Dream
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hC212 TO &hC22C
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hC211) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &h2C27EC70, &h90776841  ' Super Marioland v1.1 and Super Marioland v1.0
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hC0C0 TO &hC0C3
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hC0BF) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &h63F9407D, &h46DF91AD  ' Tetris v1.0 and v1.1
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hD000 TO &hD761
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hCFFF) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &hC1F88833  ' Asteroids
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hDB00 TO &hDB53
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hDAFF) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &hA37A814A  ' BattleCity
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hCA02 TO &hCA06
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hCA01) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &hB76C769B  ' Tetris Attack v1.0
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hCF00 TO &hCF2C
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hCEFF) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &h6C742478  ' Dig Dug
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hDE08 TO &hDE17
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hDE07) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
    CASE &h6A6ECFEC  ' Galaga & Galaxian
      IF FileExists(SaveScoresFile) <> 0 THEN
        OPEN SaveScoresFile FOR BINARY AS FileHandler
        FOR UintVar = &hD70D TO &hD716
          GET #FileHandler,, MemoryInternalRAM(UintVar)
          SaveScoresWriteProtection(UintVar - &hD70C) = UintVar
          HiScoreCheckSum += MemoryInternalRAM(UintVar)
        NEXT UintVar
        CheckSumVerification() ' Check if hiscores haven't been modified by a cheater
        CLOSE FileHandler
      END IF
  END SELECT
END SUB
