REM
REM *** High Quality video output module ***
REM This file is part of the zBoy project!
REM
REM Copyright (C) Mateusz Viste 2010
REM

'DIM SHARED Hq4ScreenBuffer(0 TO 639, 0 TO 575) AS UBYTE

SUB HighQualityProcessing4x()
  DIM AS UBYTE x, y
  DIM Situation AS STRING*9 => "    X    "
  FOR y = 2 TO 142
    FOR x = 2 TO 158
      IF ScreenBuffer(x - 1, y - 1) = ScreenBuffer(x, y) THEN Situation[0] = 88
      IF ScreenBuffer(x, y - 1) = ScreenBuffer(x, y) THEN Situation[1] = 88
      IF ScreenBuffer(x + 1, y - 1) = ScreenBuffer(x, y) THEN Situation[2] = 88
      IF ScreenBuffer(x - 1, y) = ScreenBuffer(x, y) THEN Situation[3] = 88
      IF ScreenBuffer(x + 1, y) = ScreenBuffer(x, y) THEN Situation[5] = 88
      IF ScreenBuffer(x - 1, y + 1) = ScreenBuffer(x, y) THEN Situation[6] = 88
      IF ScreenBuffer(x, y + 1) = ScreenBuffer(x, y) THEN Situation[7] = 88
      IF ScreenBuffer(x + 1, y + 1) = ScreenBuffer(x, y) THEN Situation[8] = 88
    NEXT x
  NEXT y
'  SELECT CASE Situation
'    CASE "    X    "
'    CASE "X   X   X"
'    CASE "    X    "
'    CASE "    X    "
'    CASE "    X    "
'    CASE "    X    "
'    CASE "    X    "
'    CASE ELSE
'      ScreenBuffer
'  END SELECT
END SUB


SUB RefreshScreen_EPX()
' Eric's Pixel Expansion (EPX) is an algorithm developed by Eric Johnston at LucasArts around 1992, when
' porting the SCUMM engine games from the IBM PC (which ran at 320x200x256 colors) to the early color
' Macintosh computers, which ran at more or less double that resolution. The algorithm works as follows:
'
'   A    --\ 1 2
' C P B  --/ 3 4
'   D
'  1=P; 2=P; 3=P; 4=P;
'  IF C==A AND C!=D AND A!=B => 1=A
'  IF A==B AND A!=C AND B!=D => 2=B
'  IF B==D AND B!=A AND D!=C => 4=D
'  IF D==C AND D!=B AND C!=A => 3=C

  STATIC AS UINTEGER x, y
  STATIC AS UINTEGER a, b, c, d
  STATIC AS UBYTE ScaleStepX, ScaleStepY
  STATIC AS UBYTE pixA, pixB, pixC, pixD, pixP, pix1, pix2, pix3, pix4
  STATIC AS UINTEGER pos1, pos2, pos3, pos4
  STATIC AS UBYTE EPXscaleFactor
  IF EPXscaleFactor = 0 THEN EPXscaleFactor = (GraphicScaleFactor SHR 1)  ' Init it the 1st time -> SHR 1 means "divided by 2" (faster than /2)
  DetectScreenChanges()

  IF (LcdModifiedFirstY < 255) THEN ' If no change at all occured on screen, don't give a fuck about redrawing anything
    STATIC AS UINTEGER PTR sPtr32  ' Prepare a screen pointer for 32bit color depth
    STATIC AS USHORT PTR sPtr16    ' Prepare a screen pointer for 16bit color depth
    STATIC AS UBYTE PTR sPtr8      ' Prepare a screen pointer for 8bit color depth (also used for 4bit)
    IF (sPtr32 = 0) THEN  ' If this is the first time, then init pointers
      sPtr32 = Screenptr
      sPtr16 = Screenptr
      sPtr8 = Screenptr
    END IF

    IF LcdModifiedFirstX > 0 THEN LcdModifiedFirstX -= 1  ' When using EPX, you can't work on per-pixel basis.
    IF LcdModifiedFirstY > 0 THEN LcdModifiedFirstY -= 1  ' If you change a pixel, make sure to also redraw
    IF LcdModifiedLastX < 159 THEN LcdModifiedLastX += 1  ' all its neighbours, as these could be influenced
    IF LcdModifiedLastY < 143 THEN LcdModifiedLastY += 1  ' as well.

    SCREENLOCK()
    FOR y = LcdModifiedFirstY TO LcdModifiedLastY
      IF LcdModifiedScanline(y) = 0 THEN    ' You can't ignore a single line with EPX... ignore only if neighbours haven't changed, too!
        IF y > 0 THEN
          IF LcdModifiedScanline(y - 1) = 1 THEN LcdModifiedScanline(y) = 1 ' a neighbour line changed, so cur line could change as well!
        END IF
        IF y < 143 THEN
          IF LcdModifiedScanline(y + 1) = 1 THEN LcdModifiedScanline(y) = 1 ' a neighbour line changed, so cur line could change as well!
        END IF
      END IF
      IF (LcdModifiedScanline(y) = 1) THEN
        d = (GraphicWidth * EPXscaleFactor)
        c = ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + ((y * d) SHL 1)
        FOR x = LcdModifiedFirstX TO LcdModifiedLastX

            pixP = ScreenBuffer(x, y)
            pix1 = pixP : pix2 = pixP : pix3 = pixP : pix4 = pixP
            IF y = 0 THEN pixA = pixP ELSE pixA = ScreenBuffer(x, y - 1)
            IF x = 159 THEN pixB = pixP ELSE pixB = ScreenBuffer(x + 1, y)
            IF x = 0 THEN pixC = pixP ELSE pixC = ScreenBuffer(x - 1, y)
            IF y = 143 THEN pixD = pixP ELSE pixD = ScreenBuffer(x, y + 1)
            IF (pixC = pixA) AND (pixC <> pixD) AND (pixA <> pixB) THEN pix1 = pixA
            IF (pixA = pixB) AND (pixA <> pixC) AND (pixB <> pixD) THEN pix2 = pixB
            IF (pixB = pixD) AND (pixB <> pixA) AND (pixD <> pixC) THEN pix4 = pixD
            IF (pixD = pixC) AND (pixD <> pixB) AND (pixC <> pixA) THEN pix3 = pixC

            a = c + ((x * EPXscaleFactor) SHL 1)
            FOR ScaleStepX = 0 TO (EPXscaleFactor - 1)
              b = a + ScaleStepX

              FOR ScaleStepY = 0 TO (EPXscaleFactor - 1)
                'd = (GraphicWidth * (ScaleStepY + EPXscaleFactor))

                'pos1 = (GraphicWidth * (ScaleStepY - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1)
                'pos2 = (GraphicWidth * (ScaleStepY - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1) + EPXscaleFactor
                'pos3 = (GraphicWidth * (ScaleStepY + EPXscaleFactor - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1)
                'pos4 = (GraphicWidth * (ScaleStepY + EPXscaleFactor - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1) + EPXscaleFactor

                pos1 = (GraphicWidth * ScaleStepY) + b
                pos2 = pos1 + EpxScaleFactor
                pos3 = pos1 + d
                pos4 = pos3 + EpxScaleFactor

                SELECT CASE AS CONST BitDepth
                  CASE 32
                    sPtr32[pos1] = ScreenPalette32(pix1)
                    sPtr32[pos2] = ScreenPalette32(pix2)
                    sPtr32[pos3] = ScreenPalette32(pix3)
                    sPtr32[pos4] = ScreenPalette32(pix4)
                  CASE 16
                    sPtr16[pos1] = ScreenPalette16(pix1)
                    sPtr16[pos2] = ScreenPalette16(pix2)
                    sPtr16[pos3] = ScreenPalette16(pix3)
                    sPtr16[pos4] = ScreenPalette16(pix4)
                  CASE 8
                    sPtr8[pos1] = pix1
                    sPtr8[pos2] = pix2
                    sPtr8[pos3] = pix3
                    sPtr8[pos4] = pix4
                  CASE 4
                    sPtr8[pos1] = pix1
                    sPtr8[pos2] = pix2
                    sPtr8[pos3] = pix3
                    sPtr8[pos4] = pix4
                END SELECT

              NEXT ScaleStepY
            NEXT ScaleStepX

        NEXT x
      END IF
    NEXT y
    'SCREENSYNC()   -->  serious framerate loss when activated! (but no tearing anymore...)
    SCREENUNLOCK()
  END IF
END SUB


SUB RefreshScreen_EPX3()
' The AdvMAME3x/Scale3x algorithm is not the same as EPX, but is similar in a mathematical sense.
'
' A B C --\  1 2 3
' D E F    > 4 5 6
' G H I --/  7 8 9
'  1=E; 2=E; 3=E; 4=E; 5=E; 6=E; 7=E; 8=E; 9=E;
'  IF D==B AND D!=H AND B!=F => 1=D
'  IF (D==B AND D!=H AND B!=F AND E!=C) OR (B==F AND B!=D AND F!=H AND E!=A) => 2=B
'  IF B==F AND B!=D AND F!=H => 3=F
'  IF (H==D AND H!=F AND D!=B AND E!=A) OR (D==B AND D!=H AND B!=F AND E!=G) => 4=D
'  5=E
'  IF (B==F AND B!=D AND F!=H AND E!=I) OR (F==H AND F!=B AND H!=D AND E!=C) => 6=F
'  IF H==D AND H!=F AND D!=B => 7=D
'  IF (F==H AND F!=B AND H!=D AND E!=G) OR (H==D AND H!=F AND D!=B AND E!=I) => 8=H
'  IF F==H AND F!=B AND H!=D => 9=F

  STATIC AS UINTEGER x, y
  STATIC AS UINTEGER a, b, c, d, e
  STATIC AS UBYTE ScaleStepX, ScaleStepY
  STATIC AS UBYTE pixA, pixB, pixC, pixD, pixE, pixF, pixG, pixH, pixI, pix1, pix2, pix3, pix4, pix5, pix6, pix7, pix8, pix9
  STATIC AS UINTEGER pos1, pos2, pos3, pos4, pos5, pos6, pos7, pos8, pos9
  STATIC AS UBYTE EPXscaleFactor
  IF EPXscaleFactor = 0 THEN EPXscaleFactor = (GraphicScaleFactor \ 3)  ' Init it the 1st time
  DetectScreenChanges()

  IF (LcdModifiedFirstY < 255) THEN ' If no change at all occured on screen, don't give a fuck about redrawing anything
    STATIC AS UINTEGER PTR sPtr32  ' Prepare a screen pointer for 32bit color depth
    STATIC AS USHORT PTR sPtr16    ' Prepare a screen pointer for 16bit color depth
    STATIC AS UBYTE PTR sPtr8      ' Prepare a screen pointer for 8bit color depth (also used for 4bit)
    IF (sPtr32 = 0) THEN  ' If this is the first time, then init pointers
      sPtr32 = Screenptr
      sPtr16 = Screenptr
      sPtr8 = Screenptr
    END IF

    IF LcdModifiedFirstX > 0 THEN LcdModifiedFirstX -= 1  ' When using EPX, you can't work on per-pixel basis.
    IF LcdModifiedFirstY > 0 THEN LcdModifiedFirstY -= 1  ' If you change a pixel, make sure to also redraw
    IF LcdModifiedLastX < 159 THEN LcdModifiedLastX += 1  ' all its neighbours, as these could be influenced
    IF LcdModifiedLastY < 143 THEN LcdModifiedLastY += 1  ' as well.

    SCREENLOCK()
    FOR y = LcdModifiedFirstY TO LcdModifiedLastY
      IF LcdModifiedScanline(y) = 0 THEN    ' You can't ignore a single line with EPX... ignore only if neighbours haven't changed, too!
        IF y > 0 THEN
          IF LcdModifiedScanline(y - 1) = 1 THEN LcdModifiedScanline(y) = 1 ' a neighbour line changed, so cur line could change as well!
        END IF
        IF y < 143 THEN
          IF LcdModifiedScanline(y + 1) = 1 THEN LcdModifiedScanline(y) = 1 ' a neighbour line changed, so cur line could change as well!
        END IF
      END IF
      IF (LcdModifiedScanline(y) = 1) THEN
        e = ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + ((y * GraphicWidth * EPXscaleFactor) * 3)
        FOR x = LcdModifiedFirstX TO LcdModifiedLastX

            pixE = ScreenBuffer(x, y)
            pix1 = pixE : pix2 = pixE : pix3 = pixE : pix4 = pixE : pix5 = pixE : pix6 = pixE : pix7 = pixE : pix8 = pixE : pix9 = pixE

            IF (y = 0) OR (x = 0) THEN pixA = pixE ELSE pixA = ScreenBuffer(x - 1, y - 1)
            IF (y = 0) THEN pixB = pixE ELSE pixB = ScreenBuffer(x, y - 1)
            IF (y = 0) OR (x = 159) THEN pixC = pixE ELSE pixC = ScreenBuffer(x + 1, y - 1)
            IF (x = 0) THEN pixD = pixE ELSE pixD = ScreenBuffer(x - 1, y)
            IF (x = 159) THEN pixF = pixE ELSE pixF = ScreenBuffer(x + 1, y)
            IF (x = 0) OR (y = 143) THEN pixG = pixE ELSE pixG = ScreenBuffer(x - 1, y + 1)
            IF (y = 143) THEN pixH = pixE ELSE pixH = ScreenBuffer(x, y + 1)
            IF (y = 143) OR (x = 159) THEN pixI = pixE ELSE pixI = ScreenBuffer(x + 1, y + 1)

            IF (pixD = pixB) AND (pixD <> pixH) AND (pixB <> pixF) THEN pix1 = pixD
            IF ((pixD = pixB) AND (pixD <> pixH) AND (pixB <> pixF) AND (pixE <> pixC)) OR ((pixB = pixF) AND (pixB <> pixD) AND (pixF <> pixH) AND (pixE <> pixA)) THEN pix2 = pixB
            IF (pixB = pixF) AND (pixB <> pixD) AND (pixF <> pixH) THEN pix3 = pixF
            IF ((pixH = pixD) AND (pixH <> pixF) AND (pixD <> pixB) AND (pixE <> pixA)) OR ((pixD = pixB) AND (pixD <> pixH) AND (pixB <> pixF) AND (pixE <> pixG)) THEN pix4 = pixD
            pix5 = pixE
            IF ((pixB = pixF) AND (pixB <> pixD) AND (pixF <> pixH) AND (pixE <> pixI)) OR ((pixF = pixH) AND (pixF <> pixB) AND (pixH <> pixD) AND (pixE <> pixC)) THEN pix6 = pixF
            IF (pixH = pixD) AND (pixH <> pixF) AND (pixD <> pixB) THEN pix7 = pixD
            IF ((pixF = pixH) AND (pixF <> pixB) AND (pixH <> pixD) AND (pixE <> pixG)) OR ((pixH = pixD) AND (pixH <> pixF) AND (pixD <> pixB) AND (pixE <> pixI)) THEN pix8 = pixH
            IF (pixF = pixH) AND (pixF <> pixB) AND (pixH <> pixD) THEN pix9 = pixF

            a = e + ((x * EPXscaleFactor) * 3)
            FOR ScaleStepX = 0 TO (EPXscaleFactor - 1)
              b = a + ScaleStepX
              c = b + EPXscaleFactor

              FOR ScaleStepY = 0 TO (EPXscaleFactor - 1)
                d = (GraphicWidth * (ScaleStepY + EPXscaleFactor))

                'pos2 = (GraphicWidth * (ScaleStepY - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1) + EPXscaleFactor
                'pos3 = (GraphicWidth * (ScaleStepY + EPXscaleFactor - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1)
                'pos4 = (GraphicWidth * (ScaleStepY + EPXscaleFactor - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1) + EPXscaleFactor

                pos1 = (GraphicWidth * ScaleStepY) + b
                pos2 = (GraphicWidth * ScaleStepY) + c
                pos3 = (GraphicWidth * ScaleStepY) + c + EpxScaleFactor
                pos4 = d + b
                pos5 = d + c
                pos6 = d + c + EpxScaleFactor

                pos7 = pos4 + (GraphicWidth * EpxScaleFactor)
                pos8 = pos5 + (GraphicWidth * EpxScaleFactor)
                pos9 = pos6 + (GraphicWidth * EpxScaleFactor)


                SELECT CASE AS CONST BitDepth
                  CASE 32
                    sPtr32[pos1] = ScreenPalette32(pix1)
                    sPtr32[pos2] = ScreenPalette32(pix2)
                    sPtr32[pos3] = ScreenPalette32(pix3)
                    sPtr32[pos4] = ScreenPalette32(pix4)
                    sPtr32[pos5] = ScreenPalette32(pix5)
                    sPtr32[pos6] = ScreenPalette32(pix6)
                    sPtr32[pos7] = ScreenPalette32(pix7)
                    sPtr32[pos8] = ScreenPalette32(pix8)
                    sPtr32[pos9] = ScreenPalette32(pix9)
                  CASE 16
                    sPtr16[pos1] = ScreenPalette16(pix1)
                    sPtr16[pos2] = ScreenPalette16(pix2)
                    sPtr16[pos3] = ScreenPalette16(pix3)
                    sPtr16[pos4] = ScreenPalette16(pix4)
                    sPtr16[pos5] = ScreenPalette16(pix5)
                    sPtr16[pos6] = ScreenPalette16(pix6)
                    sPtr16[pos7] = ScreenPalette16(pix7)
                    sPtr16[pos8] = ScreenPalette16(pix8)
                    sPtr16[pos9] = ScreenPalette16(pix9)
                  CASE 8
                    sPtr8[pos1] = pix1
                    sPtr8[pos2] = pix2
                    sPtr8[pos3] = pix3
                    sPtr8[pos4] = pix4
                    sPtr8[pos5] = pix5
                    sPtr8[pos6] = pix6
                    sPtr8[pos7] = pix7
                    sPtr8[pos8] = pix8
                    sPtr8[pos9] = pix9
                  CASE 4
                    sPtr8[pos1] = pix1
                    sPtr8[pos2] = pix2
                    sPtr8[pos3] = pix3
                    sPtr8[pos4] = pix4
                    sPtr8[pos5] = pix5
                    sPtr8[pos6] = pix6
                    sPtr8[pos7] = pix7
                    sPtr8[pos8] = pix8
                    sPtr8[pos9] = pix9
                END SELECT

              NEXT ScaleStepY
            NEXT ScaleStepX

        NEXT x
      END IF
    NEXT y
    'SCREENSYNC()   -->  serious framerate loss when activated! (but no tearing anymore...)
    SCREENUNLOCK()
  END IF
END SUB


SUB RefreshScreen_Eagle()
' Eagle works as follows: for every pixel we will generate 4 out pixels, first, set all 4 to
' the colour of the in pixel we are currently scaling (like nearest-neighbor), next lets look
' at the pixels up and to the left, if they are the same colour as each other set the top left
' pixel to that colour, continue doing the same for all four pixels, and then move to the next
' one.
'
' Assume an input matrix of 3x3 pixels where the center most pixel is the pixel to be scaled,
' and an output matrix of 2x2 pixels (i.e., the scaled pixel)
'
' first:        |Then 
' . . . --\ CC  |S T U  --\ 1 2
' . C . --/ CC  |V C W  --/ 3 4
' . . .         |X Y Z
'               | IF V==S==T => 1=S
'               | IF T==U==W => 2=U
'               | IF V==X==Y => 3=X
'               | IF W==Z==Y => 4=Z

  STATIC AS UINTEGER x, y
  STATIC AS UINTEGER a, b, c, d
  STATIC AS UBYTE ScaleStepX, ScaleStepY
  STATIC AS UBYTE pixS, pixT, pixU, pixV, pixC, pixW, pixX, pixY, pixZ, pix1, pix2, pix3, pix4
  STATIC AS UINTEGER pos1, pos2, pos3, pos4
  STATIC AS UBYTE EagleScaleFactor
  IF EagleScaleFactor = 0 THEN EagleScaleFactor = (GraphicScaleFactor SHR 1)  ' Init it the 1st time -> SHR 1 means "divided by 2" (faster than /2)
  DetectScreenChanges()

  IF (LcdModifiedFirstY < 255) THEN ' If no change at all occured on screen, don't give a fuck about redrawing anything
    STATIC AS UINTEGER PTR sPtr32  ' Prepare a screen pointer for 32bit color depth
    STATIC AS USHORT PTR sPtr16    ' Prepare a screen pointer for 16bit color depth
    STATIC AS UBYTE PTR sPtr8      ' Prepare a screen pointer for 8bit color depth (also used for 4bit)
    IF (sPtr32 = 0) THEN  ' If this is the first time, then init pointers
      sPtr32 = Screenptr
      sPtr16 = Screenptr
      sPtr8 = Screenptr
    END IF

    IF LcdModifiedFirstX > 0 THEN LcdModifiedFirstX -= 1  ' When using EPX, you can't work on per-pixel basis.
    IF LcdModifiedFirstY > 0 THEN LcdModifiedFirstY -= 1  ' If you change a pixel, make sure to also redraw
    IF LcdModifiedLastX < 159 THEN LcdModifiedLastX += 1  ' all its neighbours, as these could be influenced
    IF LcdModifiedLastY < 143 THEN LcdModifiedLastY += 1  ' as well.

    SCREENLOCK()
    FOR y = LcdModifiedFirstY TO LcdModifiedLastY
      IF LcdModifiedScanline(y) = 0 THEN    ' You can't ignore a single line with EPX... ignore only if neighbours haven't changed, too!
        IF y > 0 THEN
          IF LcdModifiedScanline(y - 1) = 1 THEN LcdModifiedScanline(y) = 1 ' a neighbour line changed, so cur line could change as well!
        END IF
        IF y < 143 THEN
          IF LcdModifiedScanline(y + 1) = 1 THEN LcdModifiedScanline(y) = 1 ' a neighbour line changed, so cur line could change as well!
        END IF
      END IF
      IF (LcdModifiedScanline(y) = 1) THEN
        d = (GraphicWidth * EagleScaleFactor)
        c = ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + ((y * d) SHL 1)
        FOR x = LcdModifiedFirstX TO LcdModifiedLastX

            pixC = ScreenBuffer(x, y)
            pix1 = pixC : pix2 = pixC : pix3 = pixC : pix4 = pixC
            IF (y = 0) OR (x = 0) THEN pixS = pixC ELSE pixS = ScreenBuffer(x - 1, y - 1)
            IF (y = 0) THEN pixT = pixC ELSE pixT = ScreenBuffer(x, y - 1)
            IF (y = 0) OR (x = 159) THEN pixU = pixC ELSE pixU = ScreenBuffer(x + 1, y - 1)
            IF (x = 0) THEN pixV = pixC ELSE pixV = ScreenBuffer(x - 1, y)
            IF (x = 159) THEN pixW = pixC ELSE pixW = ScreenBuffer(x + 1, y)
            IF (y = 143) OR (x = 0) THEN pixX = pixC ELSE pixX = ScreenBuffer(x - 1, y + 1)
            IF (y = 143) THEN pixY = pixC ELSE pixY = ScreenBuffer(x, y + 1)
            IF (y = 143) OR (x = 159) THEN pixZ = pixC ELSE pixZ = ScreenBuffer(x + 1, y + 1)

            IF (pixV = pixS) AND (pixS = pixT) THEN pix1 = pixS
            IF (pixT = pixU) AND (pixU = pixW) THEN pix2 = pixU
            IF (pixV = pixX) AND (pixX = pixY) THEN pix3 = pixX
            IF (pixW = pixZ) AND (pixZ = pixY) THEN pix4 = pixZ

            a = c + ((x * EagleScaleFactor) SHL 1)
            FOR ScaleStepX = 0 TO (EagleScaleFactor - 1)
              b = a + ScaleStepX

              FOR ScaleStepY = 0 TO (EagleScaleFactor - 1)
                'd = (GraphicWidth * (ScaleStepY + EPXscaleFactor))

                'pos1 = (GraphicWidth * (ScaleStepY - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1)
                'pos2 = (GraphicWidth * (ScaleStepY - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1) + EPXscaleFactor
                'pos3 = (GraphicWidth * (ScaleStepY + EPXscaleFactor - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1)
                'pos4 = (GraphicWidth * (ScaleStepY + EPXscaleFactor - 1)) + ScreenBorderRight + (ScreenBorderTop * GraphicWidth) + (y * GraphicWidth * 2 * EPXscaleFactor) + (x * 2 * EPXscaleFactor) + (ScaleStepX - 1) + EPXscaleFactor

                pos1 = (GraphicWidth * ScaleStepY) + b
                pos2 = pos1 + EagleScaleFactor
                pos3 = pos1 + d
                pos4 = pos3 + EagleScaleFactor

                SELECT CASE AS CONST BitDepth
                  CASE 32
                    sPtr32[pos1] = ScreenPalette32(pix1)
                    sPtr32[pos2] = ScreenPalette32(pix2)
                    sPtr32[pos3] = ScreenPalette32(pix3)
                    sPtr32[pos4] = ScreenPalette32(pix4)
                  CASE 16
                    sPtr16[pos1] = ScreenPalette16(pix1)
                    sPtr16[pos2] = ScreenPalette16(pix2)
                    sPtr16[pos3] = ScreenPalette16(pix3)
                    sPtr16[pos4] = ScreenPalette16(pix4)
                  CASE 8
                    sPtr8[pos1] = pix1
                    sPtr8[pos2] = pix2
                    sPtr8[pos3] = pix3
                    sPtr8[pos4] = pix4
                  CASE 4
                    sPtr8[pos1] = pix1
                    sPtr8[pos2] = pix2
                    sPtr8[pos3] = pix3
                    sPtr8[pos4] = pix4
                END SELECT

              NEXT ScaleStepY
            NEXT ScaleStepX

        NEXT x
      END IF
    NEXT y
    'SCREENSYNC()   -->  serious framerate loss when activated! (but no tearing anymore...)
    SCREENUNLOCK()
  END IF
END SUB
