REM
REM Saves the content of BigScreenBuffer to OutFile as a 160x144 PCX graphic file.
REM

'#DEFINE IntToDoubleByte(IntValue) (CHR(IntValue - (INT(IntValue / 256) * 256), INT(IntValue / 256)))

SUB SavePcxFile(BYREF OutFile AS STRING)
  DIM AS INTEGER x, y, PcxFileHandler
  DIM AS UBYTE RleCounter = 0, OldPixel
  DIM PcxDataHeader(0 TO 127) AS UBYTE => {010,005,001,008,000,000,000,000,159,000,143,000,010,000,010,000,_
                                           000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,_
                                           000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,_
                                           000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,_
                                           000,001,160,000,001,000,000,000,000,000,000,000,000,000,000,000,_
                                           000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,_
                                           000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,_
                                           000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000}
  DIM PaletteTrailer(0 TO 755) AS UBYTE
  PcxFileHandler = FREEFILE
  IF OPEN(OutFile, FOR OUTPUT, AS #PcxFileHandler) = 0 THEN
    REM Write PCX header
'    PRINT #PcxFileHandler, CHR(10);                     ' ZSoft file ID
'    PRINT #PcxFileHandler, CHR(5);                      ' PCX version (0, 1, 2, 3, 4 or 5)
'    PRINT #PcxFileHandler, CHR(1);                      ' encoding (1 = RLE)
'    PRINT #PcxFileHandler, CHR(8);                      ' Bits depth (8 = 256 colors)
'    PRINT #PcxFileHandler, CHR(0, 0);                   ' xmin
'    PRINT #PcxFileHandler, CHR(0, 0);                   ' ymin
'    PRINT #PcxFileHandler, CHR(159, 0);                 ' xmax
'    PRINT #PcxFileHandler, CHR(143, 0);                 ' ymax
'    PRINT #PcxFileHandler, CHR(10, 0);                  ' Horizontal DPI (2 bytes)
'    PRINT #PcxFileHandler, CHR(10, 0);                  ' Vertical DPI (2 bytes)
'    PRINT #PcxFileHandler, STRING(48, 0);               ' Palette for 16 colors (48 bytes)
'    PRINT #PcxFileHandler, CHR(0);                      ' reserved
'    PRINT #PcxFileHandler, CHR(1);                      ' number of color planes
'    PRINT #PcxFileHandler, CHR(160, 0);                 ' nb of bytes per line (in 8bit mode = image width)
'    PRINT #PcxFileHandler, CHR(1, 0);                   ' PaletteType (1=color/bw  2=grayscale)
'    PRINT #PcxFileHandler, CHR(0, 0);                   ' HScrSize (optional)
'    PRINT #PcxFileHandler, CHR(0, 0);                   ' VScrSize (optional)
'    PRINT #PcxFileHandler, STRING(54, 0);               ' Filler
    PUT #PcxFileHandler,, PcxDataHeader()
    REM Write PCX image data
    FOR y = 0 TO 143
      OldPixel = ScreenBuffer(0, y)
      RleCounter = 1
      FOR x = 1 TO 159
        IF (ScreenBuffer(x, y) = OldPixel) AND (RleCounter < 63) THEN
            RleCounter += 1
          ELSE
            IF (RleCounter > 1) OR (OldPixel > 191) THEN
              RleCounter = (RleCounter OR 192)
              PUT #PcxFileHandler,, RleCounter
            END IF
            PUT #PcxFileHandler,, OldPixel
            RleCounter = 1
            OldPixel = ScreenBuffer(x, y)
        END IF
      NEXT x
      IF (RleCounter > 1) OR (OldPixel > 191) THEN
        RleCounter = (RleCounter OR 192)
        PUT #PcxFileHandler,, RleCounter
      END IF
      PUT #PcxFileHandler,, OldPixel
    NEXT y
    REM Write RGB palette (768 bytes)
    RleCounter = 12
    PUT #PcxFileHandler,, RleCounter                          ' Palette byte ID (12)
    FOR x = 0 TO 3
      OldPixel = ((ScreenPalette32(x) SHR 16) AND &b11111111) ' Get Red value
      PUT #PcxFileHandler,, OldPixel                          ' Write Red value
      OldPixel = ((ScreenPalette32(x) SHR 8) AND &b11111111)  ' Get Green value
      PUT #PcxFileHandler,, OldPixel                          ' Write Green value
      OldPixel = ((ScreenPalette32(x)) AND &b11111111)        ' Get Blue value
      PUT #PcxFileHandler,, OldPixel                          ' Write Blue value
    NEXT x
    PUT #PcxFileHandler,, PaletteTrailer()   ' fill the rest of the palette with nulls
    CLOSE #PcxFileHandler
  END IF
END SUB
