REM
REM  Serial link emulation
REM  This file is part of the zBoy project
REM  Copyright (C) Mateusz Viste 2010
REM
REM
REM  FF02 is the serial control address
REM    Bit 7 - if set, the game wants to interact with serial link
REM    Bit 0 - Clock source selection (0 = external   1 = internal)
REM
REM  FF01 is the serial data buffer (for in & out operations)
REM

#MACRO CheckSerialLink()   ' For now, this procedure just fakes a Serial GB interface which is connected nowhere
  IF (NetPlay = 0) THEN  ' No net player
      IF (IoRegisters(&hFF02) AND &b10000000) > 0 THEN  ' The game tries to send some stuff out
        IF (IoRegisters(&hFF02) AND &b00000001) > 0 THEN  ' If external clock is selected, ignore, otherwise let's see
          IoRegisters(&hFF01) = &hFF   ' FF means no data has been received
          IoRegisters(&hFF0F) = (IoRegisters(&hFF0F) OR &b00001000) ' When serial handling done, request serial interrupt (INT 58), via bit 3 of FF0F
        END IF
        IoRegisters(&hFF02) = (IoRegisters(&hFF02) AND &b0111111) ' Reset the bit 7 of FF02 (see page 31 of GameBoy CPU manual)
      END IF
    ELSE  ' Net player...
      #IFDEF NETPLAYSUPPORT ' Only if enabled at compile time
        IF (IoRegisters(&hFF02) AND &b10000000) > 0 THEN  ' The game tries to send some stuff out
          'IF (IoRegisters(&hFF02) AND &b00000001) > 0 THEN  ' If external clock is selected, ignore, otherwise let's see
            NetSendByteBuff = IoRegisters(&hFF01)   ' shift $FF01 out of the serial link
            DO : LOOP UNTIL NetPollingState = 1  ' wait for something to come in
            IF NetPollingState = 1 THEN  ' We have something in da buffer
                IoRegisters(&hFF01) = NetRecvByteBuff
                NetPollingState = 0
                IoRegisters(&hFF0F) = (IoRegisters(&hFF0F) OR &b00001000) ' When serial handling done, request serial interrupt (INT 58), via bit 3 of FF0F
           '   ELSE
           '     IoRegisters(&hFF01) = &hFF   ' FF means no data has been received
            END IF

          'END IF
          IoRegisters(&hFF02) = (IoRegisters(&hFF02) AND &b0111111) ' Reset the bit 7 of FF02 (see page 31 of GameBoy CPU manual)
        END IF
      #ENDIF
  END IF
#ENDMACRO
